#include<iostream>
#include<string>
using namespace std;
class Evaluation{
	private:
		int ratedNum;		// number of T
		double average;		// score
		int* rating;		// rating others
		int* rated;			// being rated
		int lowRating;		// times of rating others for low score 
		int lowRated;		// times of being rated for low score 
	public:
		string ID;
		Evaluation();
		Evaluation(string userID);
		string getID();
		int getTradeNum();
		int getLowRating();
		int getLowRated();
		double getScore();
		void transaction(int evaluation, int evaluated);
};
class ProductList{
	private:
		string pID;
		string* seller;
		int sellerNum;
	public:
		ProductList();
		ProductList(string productID);
		int getSellerNum();
		string getPID();
		string getSeller(int sellerNumID);
		void productInfo(string merID);
};
int main(){
	string option, cusID, merID, prodID, temp;
	int cusRate, merRate;
	int cusNum = 0, merNum = 0, prodNum = 0, rateNum = 1;
	bool isUsed = 0;
	Evaluation* customer;
	Evaluation* merchant;
	ProductList* product;
	while(cin >> option){
		if(option == "C"){
			cin >> cusID;
			// check whether the customer already existed
			isUsed = 0;
			for(int i = 0; i < cusNum; i++){
				if(cusID == customer[i].getID()){
					isUsed = 1;
					break;
				}
			}
			// if the customer is new
			if(isUsed == 0){
				Evaluation* a = customer;				// construct a temp array stores data in original array
				customer = new Evaluation[cusNum+1]; 	// put the original n-array to n+1-array
				for(int i = 0; i < cusNum; i++){  		// copy data to n+1 array
					customer[i] = a[i];
				}
				Evaluation newEva = Evaluation(cusID); 	// put the new customer info to the last
				customer[cusNum] = newEva;
				if(cusNum != 0){
					delete[] a;							// release the memory space
				}
				cusNum++;
			}
		}
		// do all the same thing as "C"
		else if(option == "M"){
			cin >> merID;
			isUsed = 0;
			for(int i = 0; i < merNum; i++){
				if(merID == merchant[i].getID()){
					isUsed = 1;
					break;
				}
			}
			if(isUsed == 0){
				Evaluation* a = merchant;
				merchant = new Evaluation[merNum+1];
				for(int i = 0; i < merNum; i++){
					merchant[i] = a[i];
				}
				Evaluation newEva = Evaluation(merID);
				merchant[merNum] = newEva;
				if(merNum != 0){
					delete[] a;	
				}
				merNum++;
			}
		}
		// do the same thing as "C" & "M" 
		else if(option == "P"){
			cin >> prodID;
			isUsed = 0;
			for(int i = 0; i < prodNum; i++){
				if(prodID == product[i].getPID()){
					isUsed = 1;
					break;
				}
			}
			if(isUsed == 0){
				ProductList* a = product;
				product = new ProductList[prodNum+1];
				for(int i = 0; i < prodNum; i++){
					product[i] = a[i];
				}
				ProductList newProd = ProductList(prodID);
				product[prodNum] = newProd;
				if(prodNum != 0){
					delete[] a;	
				}
				prodNum++;
			}
		}
		else if(option == "T"){
			cin >> cusID >> merID >> prodID >> cusRate >> merRate;
			for(int i = 0; i < cusNum; i++){
				if(customer[i].getID() == cusID){
					customer[i].transaction(cusRate, merRate); 		// stores 1.the score he rates others 2.the score he gets
				}
			}
			for(int i = 0; i < merNum; i++){
				if(merchant[i].getID() == merID){
					merchant[i].transaction(merRate, cusRate);		// do the same thing
				}
			}
		}
		else if(option == "A"){
			cin >> merID >> prodID;
			for(int i = 0; i < prodNum; i++){
				if(product[i].getPID() == prodID){
					product[i].productInfo(merID);		// stores the merchant info
				}
			}
		}
		else if(option == "S"){
			int n, p;
			cin >> cusID >> prodID;
			// get the third number
			getline(cin,temp);
			rateNum = 1;
			if(temp != ""){
				rateNum = stoi(temp);
			}
			// find the product "i" and construct a new object list which contains the merchants that sold the product 
			Evaluation* rank;
			Evaluation swap;
			for(int i = 0; i < prodNum; i++){
				if(prodID == product[i].getPID()){
					p = i;
					n = product[i].getSellerNum();
					rank = new Evaluation[n];
					for(int k = 0; k < n; k++){
						for( int j = 0; j < merNum; j++){
							if(product[p].getSeller(k) == merchant[j].getID()){
								rank[k] = merchant[j];
								break;
							}
						}
					}
					break;
				}
			}
			//bubble sort according to merchant's score -> evaNum -> name
			for(int i = n-1; i>0; i--){
				for(int j = 0; j < i; j++){
					if(rank[j].getScore() > rank[j+1].getScore()){
					}	
					else if(rank[j].getScore() == rank[j+1].getScore() &&
							rank[j].getTradeNum() > rank[j+1].getTradeNum()){
					}
					else if(rank[j].getScore() == rank[j+1].getScore() && 
							rank[j].getTradeNum() == rank[j+1].getTradeNum() &&
							rank[j].getID() < rank[j+1].getID()){
					}
					else{
						swap = rank[j];
						rank[j] = rank[j+1];
						rank[j+1] = swap;	
					} 
				}
			}
			// print the outcome
			int select = 5;
			for(int i = 0; i < n; i++){
				if(rank[i].getTradeNum() >= rateNum){
					if(select != 5){
						cout << " ";
					}
					cout << rank[i].getID();
					select--;
					if(select == 0){
						break;
					}
				}
			}
			cout << endl;
			delete[] rank;
		}
		else if(option == "X"){
			cin >> merID >> cusID;
			// find customer
			for(int i = 0; i < cusNum; i++){
				if(cusID == customer[i].getID()){
					if(customer[i].getScore() < 3){
						if(customer[i].getScore() == 0){		// haven't been graded
							break;
						}
						cout << customer[i].getLowRated() << " " << customer[i].getLowRating();
						break;	
					}	
				}
			}
			cout << endl;
		}
		else{
		}
	}
	return 0;
}
Evaluation::Evaluation(){
	this->average = 0;
	this->ratedNum = 0;
}
Evaluation::Evaluation(string userID){
	ID = userID;
	this->ratedNum = 0;
	this->lowRating = 0;
	this->lowRated = 0;
	this->rating = NULL;
	this->rated = NULL;
}
string Evaluation::getID(){
	return ID;
}
int Evaluation::getTradeNum(){
	return ratedNum;
}
int Evaluation::getLowRating(){
	return lowRating;
}
int Evaluation::getLowRated(){
	return lowRated;
}
double Evaluation::getScore(){
	if(this->ratedNum == 0)
		return 0.0;
	double temp = 0.0;
	for(int i = 0; i < this->ratedNum; i++){
		temp += this->rated[i];
	}
	this->average = temp/this->ratedNum;
	return average;
}
void Evaluation::transaction(int evaluation, int evaluated){	
	// copy original array
	int* tempRating = this->rating;
	int* tempRated = this->rated;
	// n array to n+1 array
	this->rating = new int[this->ratedNum+1];
	this->rated = new int[this->ratedNum+1];	
	// copy n things to new array
	if(this->ratedNum != 0){
		for(int i = 0; i < this->ratedNum; i++){
			this->rating[i] = tempRating[i];
			this->rated[i] = tempRated[i];
		}
	}
	// put new things to new array
	this->rating[this->ratedNum] = evaluation;
	this->rated[this->ratedNum] = evaluated;
	this->ratedNum++;
	// count for X
	if(evaluated < 3){
		this->lowRated++;
		if(evaluation < 3){
			this->lowRating++;
		}
	}
	delete[] tempRating;
	delete[] tempRated;
}
ProductList::ProductList(){
}
ProductList::ProductList(string productID){	
	this->pID = productID; 
	this->seller = NULL;
	this->sellerNum = 0;
}
int ProductList::getSellerNum(){
	return this->sellerNum;
}
string ProductList::getPID(){
	return this->pID;
}
string ProductList::getSeller(int sellerNumID){
	return this->seller[sellerNumID];
}
void ProductList::productInfo(string merID){
	string* tempMer = this->seller;						// construct a temp array and copy the original array
	seller = new string[this->sellerNum+1];				// put n array to n+1 array
	if(this->sellerNum != 0){
		for(int i = 0; i < this->sellerNum; i++){
			seller[i] = tempMer[i];						// copy n objects from temp to new array
		}
	}
	seller[this->sellerNum] = merID;					// add new things to new array
	this->sellerNum++;
	delete[] tempMer;									// release the space
}
